# Game Misc #
execute as @a[tag=!spawn] run function main:spawn
bossbar set minecraft:1 players @a
#effect give @a night_vision 100000 255 true
effect give @a saturation 100000 255 true
execute as @a[tag=crawlman,x=17,y=63,z=107,distance=..3] run clear @s iron_pickaxe
execute as @a[tag=crawlman,x=17,y=63,z=107,distance=..3] run clear @s iron_block
kill @e[type=item,nbt={Item:{id:"minecraft:torch",Count:1b}}]
execute as @a[tag=crawlman,x=-14,y=70,z=106,distance=..5] run scoreboard players set $checkpoints checkpoints 1
execute as @a[tag=lavaman,x=-26,y=67,z=157,distance=..5] run scoreboard players set $checkpoints checkpoints 2
execute as @a[tag=flyman,x=-4,y=80,z=117,distance=..5] run scoreboard players set $checkpoints checkpoints 4

#Walkthrough#
scoreboard players enable @a help
execute as @a if score @s help matches 1 run function main:help

#Armor Stand Particles#

execute if entity @a[tag=admin] at @e[type=armor_stand,tag=platform] run particle happy_villager ~ ~1 ~ 0.1 0.2 0.1 0.001 1 normal
execute if entity @a[tag=admin] at @e[type=armor_stand,tag=platform2] run particle happy_villager ~ ~1 ~ 0.1 0.2 0.1 0.001 1 normal


# Kill commands #

execute as @a[tag=!swimman,tag=!admin] at @s if block ~ ~0.2 ~ water run function main:kill
execute as @a[tag=!admin] at @s if block ~ ~-0.2 ~ diorite_slab run function main:kill
execute as @a[tag=!admin] at @s if block ~ ~1.8 ~ smooth_stone_slab run function main:kill
execute as @a[tag=!lavaman,tag=!admin] at @s if block ~ ~0.2 ~ lava run function main:kill

# Crumbling Playform #
execute as @a[tag=speedman] at @s if block ~ ~-.5 ~ cobblestone_slab[type=top] align xyz unless entity @e[type=area_effect_cloud,dx=0,dy=0,dz=0] run summon area_effect_cloud ~.5 ~.5 ~.5 {Duration:15,Radius:0f}
execute as @a[tag=crawlman] at @s if block ~ ~-.2 ~ cobblestone_slab[type=top] align xyz unless entity @e[type=area_effect_cloud,dx=0,dy=0,dz=0] run summon area_effect_cloud ~.5 ~.5 ~.5 {Duration:15,Radius:0f}


execute as @e[type=area_effect_cloud] run scoreboard players add @s timer 1
execute as @e[type=area_effect_cloud] at @s if score @s timer matches 3 run setblock ~ ~-1 ~ air
execute as @e[type=area_effect_cloud] at @s if score @s timer matches 15 run setblock ~ ~-1 ~ cobblestone_slab[type=top]



# Platforms #
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 61 run scoreboard players set $timer PlatformsActive 1


execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 20 at @e[type=minecraft:armor_stand,tag=platform,tag=1] run setblock ~ ~-1 ~ minecraft:air
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 30 at @e[type=minecraft:armor_stand,tag=platform,tag=2] run setblock ~ ~-1 ~ minecraft:air
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 40 at @e[type=minecraft:armor_stand,tag=platform,tag=3] run setblock ~ ~-1 ~ minecraft:air
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 50 at @e[type=minecraft:armor_stand,tag=platform,tag=4] run setblock ~ ~-1 ~ minecraft:air

execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 40 at @e[type=minecraft:armor_stand,tag=platform,tag=1] run setblock ~ ~-1 ~ minecraft:red_sandstone
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 50 at @e[type=minecraft:armor_stand,tag=platform,tag=2] run setblock ~ ~-1 ~ minecraft:red_sandstone
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 60 at @e[type=minecraft:armor_stand,tag=platform,tag=3] run setblock ~ ~-1 ~ minecraft:red_sandstone
execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches 20 at @e[type=minecraft:armor_stand,tag=platform,tag=4] run setblock ~ ~-1 ~ minecraft:red_sandstone

execute if score $active PlatformsActive matches 1 if score $timer PlatformsActive matches ..60 run scoreboard players add $timer PlatformsActive 1

execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 41 run scoreboard players set $timer2 PlatformsActive 1

execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 10 at @e[type=minecraft:armor_stand,tag=platform2,tag=1] run setblock ~ ~-1 ~ minecraft:air
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 30 at @e[type=minecraft:armor_stand,tag=platform2,tag=2] run setblock ~ ~-1 ~ minecraft:air
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 10 at @e[type=minecraft:armor_stand,tag=platform2,tag=3] run setblock ~ ~-1 ~ minecraft:air
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 40 at @e[type=minecraft:armor_stand,tag=platform2,tag=4] run setblock ~ ~-1 ~ minecraft:air
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 30 at @e[type=minecraft:armor_stand,tag=platform2,tag=5] run setblock ~ ~-1 ~ minecraft:air

execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 40 at @e[type=minecraft:armor_stand,tag=platform2,tag=1] run setblock ~ ~-1 ~ minecraft:cracked_polished_blackstone_bricks
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 10 at @e[type=minecraft:armor_stand,tag=platform2,tag=2] run setblock ~ ~-1 ~ minecraft:cracked_polished_blackstone_bricks
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 40 at @e[type=minecraft:armor_stand,tag=platform2,tag=3] run setblock ~ ~-1 ~ minecraft:cracked_polished_blackstone_bricks
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 10 at @e[type=minecraft:armor_stand,tag=platform2,tag=4] run setblock ~ ~-1 ~ minecraft:cracked_polished_blackstone_bricks
execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches 30 at @e[type=minecraft:armor_stand,tag=platform2,tag=5] run setblock ~ ~-1 ~ minecraft:cracked_polished_blackstone_bricks

execute if score $active2 PlatformsActive matches 1 if score $timer2 PlatformsActive matches ..40 run scoreboard players add $timer2 PlatformsActive 1

execute if score $active PlatformsActive matches 0 at @e[type=minecraft:armor_stand,tag=platform] run setblock ~ ~-1 ~ minecraft:red_sandstone
execute if score $active2 PlatformsActive matches 0 at @e[type=minecraft:armor_stand,tag=platform2] run setblock ~ ~-1 ~ minecraft:cracked_polished_blackstone_bricks

execute if score $active PlatformsActive matches 0 run scoreboard players set $timer PlatformsActive 0
execute if score $active2 PlatformsActive matches 0 run scoreboard players set $timer2 PlatformsActive 0

# Ability Switch #

execute if score $toggle ability matches 0 at @a[x=-47,y=68,z=97,distance=..3,tag=jumpman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1
execute if score $toggle ability matches 0 at @a[x=-47,y=68,z=97,distance=..3,tag=crawlman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1
execute if score $toggle ability matches 0 at @a[x=-47,y=68,z=97,distance=..3,tag=swimman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1
execute if score $toggle ability matches 0 at @a[x=-47,y=68,z=97,distance=..3,tag=speedman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1
execute if score $toggle ability matches 0 at @a[x=-47,y=68,z=97,distance=..3,tag=lavaman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1
execute if score $toggle ability matches 0 if score $check greedyman matches 1 at @a[x=-47,y=68,z=97,distance=..3,tag=greedyman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1
execute if score $toggle ability matches 0 at @a[x=-47,y=68,z=97,distance=..3,tag=flyman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] if block ~ ~-2.1 ~ minecraft:magma_block run scoreboard players set $toggle ability 1

execute if score $1 ability matches 1 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=jumpman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch
execute if score $1 ability matches 2 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=crawlman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch
execute if score $1 ability matches 3 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=swimman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch
execute if score $1 ability matches 4 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=speedman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch
execute if score $1 ability matches 5 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=lavaman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch
execute if score $1 ability matches 6 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=greedyman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch
execute if score $1 ability matches 7 if score $toggle ability matches 1 as @a[x=-47,y=68,z=97,distance=..3,tag=flyman,nbt={Inventory:[{id:"minecraft:totem_of_undying"}]}] at @s if block ~ ~-2.1 ~ minecraft:magma_block run function main:abilityswitch

# Ability effects #
execute if score $1 ability matches 2 run effect give @a jump_boost 100000 128 true
execute if score $1 ability matches 3 run effect give @a jump_boost 100000 128 true
execute if score $1 ability matches 4 run effect give @a jump_boost 100000 128 true
execute if score $1 ability matches 5 run effect give @a jump_boost 100000 128 true
execute if score $1 ability matches 7 run effect give @a jump_boost 100000 128 true

execute if score $1 ability matches 4 run effect give @a speed 100000 1 true
execute if score $1 ability matches 5 run effect give @a fire_resistance 100000 10 true
execute if score $1 ability matches 6 run effect give @a fire_resistance 10 10 true

#BlockDrop Tag#

execute if score $1 ability matches 2 as @e[type=item,nbt={Item:{id:"minecraft:iron_block"}}] run data merge entity @s {Item:{tag:{CanPlaceOn:["minecraft:cut_sandstone"]}}}

execute if score $1 ability matches 5 as @e[type=item,nbt={Item:{id:"minecraft:iron_block"}}] run data merge entity @s {Item:{tag:{CanPlaceOn:["minecraft:blackstone"]}}}
execute if score $1 ability matches 5 as @e[type=item,nbt={Item:{id:"minecraft:redstone"}}] run data merge entity @s {Item:{tag:{CanPlaceOn:["minecraft:blackstone","minecraft:iron_block"]}}}
execute if score $1 ability matches 5 as @e[type=item,nbt={Item:{id:"minecraft:repeater"}}] run data merge entity @s {Item:{tag:{CanPlaceOn:["minecraft:blackstone","minecraft:iron_block"]}}}


#Speedman#
execute if entity @a[tag=speedman] run fill 13 62 122 11 62 124 smooth_sandstone
execute if entity @a[tag=!speedman] run fill 13 62 122 11 62 124 water

execute if entity @a[tag=speedman] run fill 13 63 125 11 63 125 air
execute if entity @a[tag=!speedman] run fill 13 63 125 11 63 125 smooth_sandstone

#Lavaman#
execute if block 6 68 157 air at @a[tag=lavaman,x=3,y=67,z=157,distance=..3] run clear @a[tag=lavaman]
execute at @a[tag=lavaman,x=-12,y=67,z=157,distance=..3] run clear @a[tag=lavaman]
execute if block 37 67 156 minecraft:redstone_wall_torch[lit=false,facing=west] run setblock 36 65 157 air
execute if block 37 67 156 minecraft:redstone_wall_torch[lit=true,facing=west] run setblock 36 65 157 redstone_block

execute at @a[tag=lavaman,x=2,y=67,z=157,distance=..3] run fill 6 67 157 6 68 157 minecraft:polished_blackstone
kill @e[type=item,nbt={Item:{id:"minecraft:piston"}}] 

#lock#
execute if entity @a[tag=!greedyman] run data merge block 50 68 125 {Lock:"locked"}
execute if entity @a[tag=!greedyman] run data merge block 31 64 107 {Lock:"locked"}
execute if entity @a[tag=!greedyman] run data merge block 13 63 98 {Lock:"locked"}
execute if entity @a[tag=!greedyman] run data merge block -12 63 96 {Lock:"locked"}
execute if entity @a[tag=!greedyman] run data merge block -12 70 108 {Lock:"locked"}
execute if entity @a[tag=!greedyman] run data merge block -32 70 112 {Lock:"locked"}

execute if score $checkpoints checkpoints matches 3 run data merge block 50 68 125 {Lock:"locked"}
execute if score $checkpoints checkpoints matches 3 run data merge block 31 64 107 {Lock:"locked"}
execute if score $checkpoints checkpoints matches 3 run data merge block 13 63 98 {Lock:"locked"}
execute if score $checkpoints checkpoints matches 3 run data merge block -12 63 96 {Lock:"locked"}
execute if score $checkpoints checkpoints matches 3 run data merge block -12 70 108 {Lock:"locked"}
execute if score $checkpoints checkpoints matches 3 run data merge block -32 70 112 {Lock:"locked"}

execute if entity @a[tag=greedyman] if score $checkpoints checkpoints matches 2 run data merge block 50 68 125 {Lock:""}
execute if entity @a[tag=greedyman] if score $checkpoints checkpoints matches 2 run data merge block 31 64 107 {Lock:""}
execute if entity @a[tag=greedyman] if score $checkpoints checkpoints matches 2 run data merge block 13 63 98 {Lock:""}
execute if entity @a[tag=greedyman] if score $checkpoints checkpoints matches 2 run data merge block -12 63 96 {Lock:""}
execute if entity @a[tag=greedyman] if score $checkpoints checkpoints matches 2 run data merge block -12 70 108 {Lock:""}
execute if entity @a[tag=greedyman] if score $checkpoints checkpoints matches 2 run data merge block -32 70 112 {Lock:""}

#Greedyman#

execute if entity @a[tag=greedyman,nbt={Inventory:[{id:"minecraft:raw_gold"}]}] run function main:greedyman/clear

execute if score $a greedyman matches 1 if score $t greedyman matches ..201 run scoreboard players add $t greedyman 1
execute if score $a greedyman matches 1 if score $t greedyman matches 201 as @a[tag=greedyman] run function main:kill

execute if score $a greedyman matches 1 if score $t greedyman matches 20 run bossbar set minecraft:1 value 9
execute if score $a greedyman matches 1 if score $t greedyman matches 40 run bossbar set minecraft:1 value 8
execute if score $a greedyman matches 1 if score $t greedyman matches 60 run bossbar set minecraft:1 value 7
execute if score $a greedyman matches 1 if score $t greedyman matches 80 run bossbar set minecraft:1 value 6
execute if score $a greedyman matches 1 if score $t greedyman matches 100 run bossbar set minecraft:1 value 5
execute if score $a greedyman matches 1 if score $t greedyman matches 120 run bossbar set minecraft:1 value 4
execute if score $a greedyman matches 1 if score $t greedyman matches 140 run bossbar set minecraft:1 value 3
execute if score $a greedyman matches 1 if score $t greedyman matches 160 run bossbar set minecraft:1 value 2
execute if score $a greedyman matches 1 if score $t greedyman matches 180 run bossbar set minecraft:1 value 1
execute if score $a greedyman matches 1 if score $t greedyman matches 200 run bossbar set minecraft:1 value 0

execute if score $s greedyman matches 7 run function main:greedyman/collected

execute if entity @a[tag=greedyman] run clear @a raw_gold_block

execute if entity @a[tag=greedyman,x=11,y=67,z=117,distance=..4] as @a run function main:kill

#Flyman#

execute as @a[tag=flyman] at @s if block ~ ~-0.5 ~ emerald_block run effect give @a levitation 4 5 true

#Start#
execute if score $1 start matches 0 run kill @e[type=minecraft:armor_stand,tag=startscene]

execute if score $1 start matches 1 if score $2 start matches 2 run summon armor_stand 55 69 117 {NoGravity:1b,Silent:1b,Invulnerable:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["startscene"],Rotation:[-90F,3F]}
execute as @a[tag=!admin] if score $1 start matches 1 if score $2 finish matches ..200 run spectate @e[type=minecraft:armor_stand,tag=startscene,limit=1] @s
execute if score $1 start matches 1 if score $2 start matches ..200 run scoreboard players add $2 start 1
execute if score $1 start matches 1 if score $2 start matches ..150 at @e[type=minecraft:armor_stand,tag=startscene] as @e[type=minecraft:armor_stand,tag=startscene] run tp @e[type=minecraft:armor_stand,tag=startscene] ~-0.03 ~ ~ ~ ~
execute if score $1 start matches 1 if score $2 start matches 151 run clone 66 62 105 66 64 107 56 67 116
execute if score $1 start matches 1 if score $2 start matches 152 run kill @e[tag=startwall]
execute if score $1 start matches 1 if score $2 start matches 150.. at @e[type=minecraft:armor_stand,tag=startscene] as @e[type=minecraft:armor_stand,tag=startscene] run tp @e[type=minecraft:armor_stand,tag=startscene] ~-0.01 ~ ~ ~3.6 ~

execute if score $1 start matches 1 if score $2 start matches 1 run summon armor_stand 56 70 117 {NoGravity:1b,Silent:1b,Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,Tags:["startwall"],Rotation:[-90F,0F],ArmorItems:[{},{},{},{id:"minecraft:stick",Count:1b,tag:{CustomModelData:103}}]}
execute if score $1 start matches 1 if score $2 start matches 1 at @e[type=minecraft:armor_stand,tag=startwall] as @e[type=minecraft:armor_stand,tag=startwall] run playsound sound.tombwall master @a ~ ~ ~ 0.7 1 1
execute if score $1 start matches 1 if score $2 start matches ..150 at @e[type=minecraft:armor_stand,tag=startwall] as @e[type=minecraft:armor_stand,tag=startwall] run tp @e[type=minecraft:armor_stand,tag=startwall] ~ ~-.02 ~ ~ ~
execute if score $1 start matches 1 if score $2 start matches 200 run function main:start/cutscenefin

#Finish#
execute if score $1 finish matches 0 run kill @e[type=minecraft:armor_stand,tag=finish]

execute as @a if score $1 finish matches 1 if score $2 finish matches ..400 run spectate @e[type=minecraft:armor_stand,tag=finish,limit=1] @s
execute if score $1 finish matches 1 if score $2 finish matches ..400 run scoreboard players add $2 finish 1
execute if score $2 finish matches ..400 at @e[type=minecraft:armor_stand,tag=finish] as @e[type=minecraft:armor_stand,tag=finish] run tp @e[type=minecraft:armor_stand,tag=finish] ~ ~.05 ~ ~ ~.01

execute if score $2 finish matches 10 run setblock -49 70 95 air
execute if score $2 finish matches 10 run setblock -45 70 95 air

execute if score $2 finish matches 20 run particle minecraft:happy_villager -46.52 70.36 96.00 0.5 0.5 0.5 0.01 100 normal

execute if score $2 finish matches 100 run function main:finish/fade

execute if score $1 finish matches 0 if score $1 start matches 0 run gamemode adventure @a[tag=!admin]

#Offerings#

execute unless entity @e[type=item,tag=offering] run setblock -23 66 117 smooth_red_sandstone
execute unless entity @e[type=item,tag=offering] run setblock -28 70 108 smooth_red_sandstone
execute unless entity @e[type=item,tag=offering] run setblock 16 69 127 smooth_sandstone
execute unless entity @e[type=item,tag=offering] run setblock -47 61 135 smooth_red_sandstone
execute unless entity @e[type=item,tag=offering] run setblock -57 67 85 smooth_red_sandstone
execute unless entity @e[type=item,tag=offering] run setblock -14 62 104 smooth_sandstone
execute unless entity @e[type=item,tag=offering] run setblock -5 79 117 smooth_sandstone